const fetch = require("node-fetch");

class Commands {
  async getMeme() {
    const main = await fetch("https://no-api-key.com/api/v1/memes");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        title: "Here's a meme",
        image: { url: data.image }
      }
    };

    return content;
  }

  async getDog() {
    const main = await fetch("https://no-api-key.com/api/v1/animals/dog");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        description: data.fact ,
        image: { url: data.image }
      }
    };

    return content;
  }
  
  async getCat() {
    const main = await fetch("https://no-api-key.com/api/v1/animals/cat");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        description: data.fact ,
        image: { url: data.image }
      }
    };

    return content;
  }

  async getBear() {
    const main = await fetch("https://no-api-key.com/api/v1/animals/bear");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        description: data.fact ,
        image: { url: data.image }
      }
    };

    return content;
  }

  async getPanda() {
    const main = await fetch("https://no-api-key.com/api/v1/animals/panda");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        description: data.fact ,
        image: { url: data.image }
      }
    };

    return content;
  }

  async getJoke() {
    const main = await fetch("https://apis.duncte123.me/joke");
    const data = await main.json();

    if (!data.success) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = { embed: { title: data.data.title, color: "RANDOM" } };

    if (data.data.body) {
      content.embed.description = data.data.body;
    }

    return content;
  }

  async getNeko() {
    const main = await fetch("https://neko-love.xyz/api/v1/neko");
    const data = await main.json();

    if (data.code !== 200) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        title: "NEKO",
        image: { url: data.url }
      }
    };

    return content;
  }

  async getQuote() {
    const main = await fetch("https://no-api-key.com/api/v1/quotes");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        author: data.author ,
        description: data.quote
      }
    };

    return content;
  }

  async getKpop() {
    const main = await fetch("https://apis.duncte123.me/kpop");
    const data = await main.json();

    if (!data.success) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = {
      embed: {
        color: "RANDOM",
        title: data.data.name,
        image: { url: data.data.img }
      }
    };

    return content;
  }

  async getAdvice() {
    const main = await fetch("https://api.adviceslip.com/advice");
    const data = await main.json();

    if (!data) {
      return console.log("Error 01: Unable to access the json content of API");
    }

    let content = { embed: { description: data.slip.advice, color: "RANDOM" } };

    return content;
  }
  
  async getFact() {
    const main = await fetch('https://bruhapi.xyz/fact').then((res) => res.json());
    let content = { embed: { description: main.res, color: 'RANDOM' } };
    return content;
  }
  
}
module.exports = Commands;